﻿using System;
using System.Collections.Generic;
using System.Text;
using MathEx.ExternalBallistic.JBM;

namespace MathTest
{
    class Program
    {
        static void Main(string[] args)
        {
            TestJBM();
        }

        static void TestJBM()
        {
            Atmo a = new Atmo();
            Bullet b = new Bullet(0.440, DragTable.G7);
            Rifle r = new Rifle(3500, 1.5 / 12);
            Shot s = new Shot(45.0 / 180.0 * Math.PI, 0, 3.5 / 1800.0 * Math.PI);
            Wind w = new Wind(30, 45.0 / 180.0 * Math.PI);

            RangeData[] rgs = JbmCalculator.calculate(b, r, a, s, w, 656.167979, 16400.41995, 32.808399, false, true);
            //RangeData[] rgs = JbmCalculator.calculate(b, r, a, s, null, 0, 500, 25, false, true);

            Console.WriteLine("{0} {1}", s.Elevation * 60 * 180 / System.Math.PI, s.Elevation * 180 / System.Math.PI);

            for (int i = 0; i < rgs.Length && rgs[i] != null; i++)
            {
                Console.WriteLine("{4:d3}: {0,8:f3} {1,4:f1} {2,6:f1} {3,4:f1}", rgs[i].Range / 3.2808399, rgs[i].Drop * 12, rgs[i].Velocity, rgs[i].Windage * 12, i);
            }
        }
    }
}
